/*
   YF-S201 Hall Effect Wasser-/Durchfluss-Sensor
   https://www.roboter-bausatz.de/detail/index/sArticle/1156
   Anleitung von http://www.theorycircuit.com/water-flow-sensor-yf-s201-arduino-interface/
   
   Sketch zum Messen und Lesen des Outputs in Liter/Stunde

*/

volatile int  flow_frequency;  // Pulsfrequenz messen
unsigned int  l_hour;          // Liter/Stunde berechnen                      
unsigned char flowmeter = 2;  // Sensor Pin
unsigned long currentTime;
unsigned long cloopTime;

void flow ()                  // Interrupt
{ 
   flow_frequency++;
} 

void setup()
{ 
   pinMode(flowmeter, INPUT);
   Serial.begin(9600); 
   attachInterrupt(0, flow, RISING); // Initalisiere Interrupt 
                                     // siehe http://arduino.cc/en/Reference/attachInterrupt
   sei();                            // Aktiviere Interrupt
   currentTime = millis();
   cloopTime = currentTime;
} 

void loop ()    
{
   currentTime = millis();
   // Sekündlich den Durchfluss in Liter/Stunde berechnen und ausgeben
   if(currentTime >= (cloopTime + 1000))
   {     
      cloopTime = currentTime;              // Updates cloopTime
      // Pulsfrequenz (Hz) = 7.5Q, Q ist die Flussrate in L/min. (Ergebnisse innerhalb +/- 3% Toleranzen)
      l_hour = (flow_frequency * 60 / 7.5); // (Pulsfrequenz x 60 Min) / 7.5Q = Flussrate in Liter/Stunde
      flow_frequency = 0;                   // Reset Counter
      Serial.print(l_hour, DEC);            // Ausgabe der Flussrate in Liter/Stunde
      Serial.println(" L/hour");
   }
}
